package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUserProvider;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedException;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.UserAndSliceApiWrapper;
import be.iminds.ilabt.jfed.highlevel.util.JavaFXLogger;

import javax.annotation.Nonnull;
import java.util.Collections;
import java.util.List;

/**
 * User: twalcari
 * Date: 6/16/2015
 * Time: 17:32
 */
public class UserSshKeysTask extends Task {

    @Nonnull private final UserAndSliceApiWrapper userAndSliceApiWrapper;
    @Nonnull private final JavaFXLogger logger;
    @Nonnull private final GeniUserProvider geniUserProvider;
    @Nonnull private final HighLevelTaskFactory highLevelTaskFactory;

    public UserSshKeysTask(@Nonnull UserAndSliceApiWrapper userAndSliceApiWrapper,
                           @Nonnull JavaFXLogger logger,
                           @Nonnull GeniUserProvider geniUserProvider,
                           @Nonnull HighLevelTaskFactory highLevelTaskFactory) {
        super("Get User SSH Keys");
        this.userAndSliceApiWrapper = userAndSliceApiWrapper;
        this.logger = logger;
        this.geniUserProvider = geniUserProvider;
        this.highLevelTaskFactory = highLevelTaskFactory;
    }

    @Override
    public void doTask(@Nonnull TaskExecution taskExecution) throws JFedException, InterruptedException {
        userAndSliceApiWrapper.getSshKeysForUser(JavaFXLogger.wrap(logger, taskExecution),
                geniUserProvider.getLoggedInGeniUser().getUserUrn());

    }

    @Nonnull
    @Override
    public List<Task> initDependsOn() {
        return Collections.singletonList(highLevelTaskFactory.getUserCredential());
    }
}
